#ifndef _wargs_h_
#define _wargs_h_

class WArgList {
protected :
	ArgList	args;
	Cardinal num_args;
	Cardinal alloc_args;

	Arg&	Grow (Cardinal n);
public :
inline		WArgList ();
		WArgList (String name, XtArgVal value, ...);
inline		WArgList (Cardinal len);
inline		WArgList (ArgList a, Cardinal n);
inline		WArgList (const WArgList&);
inline		~WArgList ();
inline	ArgList	Args () const	{ return args; }
inline	Cardinal NumArgs () const { return num_args; }
inline	void	Reset ()	{ num_args = 0; }
inline	Arg&	operator [] (Cardinal n);
inline	WArgList& Add (String name, void* value);
inline	WArgList& Add (String name, long value);
#ifdef _CC_XmString_h
inline	WArgList& Add (String name, const WXmString& value);
#endif

	friend class WObject;
	friend class CConstraint;
};

inline
WArgList :: WArgList ()
{
	args = 0;
	num_args = alloc_args = 0;
}

inline
WArgList :: WArgList (Cardinal len)
{
	args = new Arg[len];
	num_args = 0;
	alloc_args = len;
}

inline
WArgList :: WArgList (ArgList a, Cardinal n)
{
	args = a;
	num_args = n;
	alloc_args = 0;
}

inline Arg&
WArgList :: operator [] (Cardinal n)
{
	if (n < num_args|| n < alloc_args)
		return args[n];
	else
		return Grow(n);
}

inline WArgList&
WArgList :: Add (String name, void* value)
{
	Arg&	a = (*this)[num_args];
	num_args++;
	a.name = name;
	a.value = (XtArgVal)value;
	return *this; 
}

inline WArgList&
WArgList :: Add (String name, long value)
{
	Arg&	a = (*this)[num_args];
	num_args++;
	a.name = name;
	a.value = (XtArgVal)value;
	return *this; 
}

#ifdef _CC_XmString_h
inline WArgList&
WArgList :: Add (String name, const WXmString& value)
{
	return Add(name, (XmString)value);
}
#endif
#endif
