/*
 *	WWL		(c) Copyright LRI 1990
 *
 *	C++ Callbacks
 *
 *	$Id: wcallback.h,v 1.3 90/09/18 12:53:26 mbl Exp $
 *	$CurLog$        (Log at end)
 */

#ifndef _wcallback_h_
#define _wcallback_h_

class WWL;
class WCallback;
typedef void (WWL::* WWL_FUN) (WCallback*);

class WWL {
protected:
	WCallback*	cbList;
public:
	WWL ();
	~WWL ();
	
	void		AddCb (WCallback*);
	Boolean		RemoveCb (WCallback*);
};

class WCallback {
protected:
	WCallback*	next;
	Widget		widget;
	const char*	name;
	WWL*		object;
	WWL_FUN	fun;
	caddr_t		data;
	
public:
	WCallback (Widget, const char*, WWL*, WWL_FUN);
	~WCallback ();
	
	void	Call (caddr_t);
	
inline	WWL_FUN	Fun ()			{ return fun; }
inline	void		Fun (WWL_FUN f)	{ fun = f; }
inline	WWL*		Obj ()			{ return object; }
inline	void		Obj (WWL* o)		{ o->AddCb (this); }
inline	caddr_t		Data ()			{ return data; }
inline	Widget		GetWidget ()		{ return widget; }
friend	class WWL;
};

#endif

/*
 *	$Log:	wcallback.h,v $
 *	Revision 1.3  90/09/18  12:53:26  mbl
 *	Added GetWidget().
 *	
 *	
 *	Revision 1.2  90/08/13  19:36:24  mbl
 *	added RCS header
 *	
 */
